package com.supwisdom.institute.backend.base.api.v1.admin;

import java.util.HashMap;
import java.util.Map;

import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.RestController;

import com.supwisdom.institute.backend.base.api.vo.response.PermissionTreeResponseData;
import com.supwisdom.institute.backend.base.domain.model.PermissionTreeNode;
import com.supwisdom.institute.backend.base.domain.service.PermissionService;
import com.supwisdom.institute.backend.common.framework.vo.response.DefaultApiResponse;

@Api(value = "BaseAdminPermission", tags = { "BaseAdminPermission" }, description = "权限的操作接口")
@Slf4j
@RestController
@RequestMapping("/v1/admin/permissions")
public class AdminPermissionController {

  @Autowired
  private PermissionService permissionService;

  @GetMapping(path = "/tree", produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
  @ResponseStatus(value = HttpStatus.OK)
  @ResponseBody
  public DefaultApiResponse<PermissionTreeResponseData> tree() {
    
    Map<String, Object> mapBean = new HashMap<String, Object>();
    //mapBean.put("type", Permission.TYPE_MENU);

    PermissionTreeNode tree = permissionService.selectPermissionTree(mapBean);

    PermissionTreeResponseData data = PermissionTreeResponseData.of(tree);

    return new DefaultApiResponse<PermissionTreeResponseData>(data);
  }
  
}
